# Getting started

- There are some user-centric tutorials that will introduce you to features of *FluxTraining.jl* one at a time
- Alternatively you can read more about how *FluxTraining.jl* is implemented and how you can extend it

## Tutorials

- [MNIST training](./tutorials/mnist.ipynb)
- [Hyperparameter scheduling](./tutorials/hyperparameters.md)

## Interfaces

### Training loop

Find out how [the training loop](training/basics.md) is built and how to customize it.

### Callbacks

Callbacks are a powerful feature of *FluxTraining.jl*, allowing you to add functionality to the training loop at different points.

Find out

- how to [use callbacks](./callbacks/usage.md) when training
- what callbacks come [included with *FluxTraining.jl*](./callbacks/reference.md); or
- how callbacks work and how to [implement your own](./callbacks/custom.md)